/*
 * GPS Navigation ---An open source GPS navigation core software
 *
 *
 * Copyright (c) 2016  Aisin AW, Ltd
 *
 * This program is dual licensed under GPL version 2 or a commercial license.
 * See the LICENSE file distributed with this source file.
 */
#ifndef GENIVI_MAPVIEWER_CONSTANTS_H
#define GENIVI_MAPVIEWER_CONSTANTS_H

#define MAPVIEWER_INVALID 0x0000
#define MAPVIEWER_ALL 0xffff
#define MAPVIEWER_AVAILABLE 0x0001
#define MAPVIEWER_NOT_AVAILABLE 0x0002
#define MAPVIEWER_TIME_FORMAT 0x0003
#define MAPVIEWER_12H 0x0004
#define MAPVIEWER_24H 0x0005
#define MAPVIEWER_COORDINATES_FORMAT 0x0006
#define MAPVIEWER_DEGREES 0x0007
#define MAPVIEWER_MINUTES 0x0008
#define MAPVIEWER_SECONDS 0x0009
#define MAPVIEWER_MAIN_MAP 0x0010
#define MAPVIEWER_SPLIT_SCREEN 0x0011
#define MAPVIEWER_2D 0x0020
#define MAPVIEWER_3D 0x0021
#define MAPVIEWER_LOCALE 0x0025
#define MAPVIEWER_UNITS_OF_MEASUREMENT 0x0030
#define MAPVIEWER_LENGTH 0x0031
#define MAPVIEWER_METER 0x0032
#define MAPVIEWER_MILE 0x0033
#define MAPVIEWER_KM 0x0034
#define MAPVIEWER_YARD 0x0035
#define MAPVIEWER_FOOT 0x0036
#define MAPVIEWER_MIN 0x0040
#define MAPVIEWER_MAX 0x0041
#define MAPVIEWER_MID 0x0042
#define MAPVIEWER_VISIBLE 0x0043
#define MAPVIEWER_INVISIBLE 0x0044
#define MAPVIEWER_FROZEN 0x0045
#define MAPVIEWER_LEVEL1 0x0050
#define MAPVIEWER_LEVEL2 0x0051
#define MAPVIEWER_LEVEL3 0x0052
#define MAPVIEWER_LEVEL4 0x0053
#define MAPVIEWER_LEVEL5 0x0054
#define MAPVIEWER_THEME_1 0x0060
#define MAPVIEWER_THEME_2 0x0061
#define MAPVIEWER_THEME_3 0x0062
#define MAPVIEWER_CONSTANT_ANGLE 0x0070
#define MAPVIEWER_TRACK_UP 0x0071
#define MAPVIEWER_TOWARDS_TARGET 0x0072
#define MAPVIEWER_PAN_START 0x0100
#define MAPVIEWER_PAN_TO 0x0101
#define MAPVIEWER_PAN_END 0x0102
#define MAPVIEWER_BUILDINGS 0x0080
#define MAPVIEWER_TERRAIN 0x0081
#define MAPVIEWER_AUTOMATIC 0x0110
#define MAPVIEWER_MANUAL 0x0111
#define MAPVIEWER_HYBRID 0x0112
#define MAPVIEWER_CUSTOM_ELEMENT 0x0120
#define MAPVIEWER_CURRENT_POSITION 0x0121
#define MAPVIEWER_WAYPOINT 0x0122
#define MAPVIEWER_POI 0x0123
#define MAPVIEWER_TRAFFIC_INCIDENT 0x0124
#define MAPVIEWER_ROUTE 0x0125
#define MAPVIEWER_GEOCOORDINATES 0x0126

#endif
